#include <gb/gb.h>
#include "sound.h"

UBYTE sound_init()
{
	// Initialize sound chip
	NR52_REG = 0xF8U;
	NR51_REG = 0x00U;
	NR50_REG = 0xFFU;
}

UBYTE sound_enter_pressed_ch1()
{
	NR10_REG = 0x04U;
	NR11_REG = 0xFEU;
	NR12_REG = 0xA1U;
	NR13_REG = 0x8FU;
	NR14_REG = 0x86U;
	NR51_REG = 0xF7;
	return 0u;
}

UBYTE sound_cookie_pickup_ch1()
{
	NR10_REG = 0x74U; // 1st - 3rd bits give number of sweep shifts
			  // 4th bit indicates if freq increases or decreases
			  // bits 5th-7th indicate sweep delay
	NR11_REG = 0x80U; // 1st - 3rd bits are sound length
	NR12_REG = 0xF0U;
	NR13_REG = 0x0AU; //lowest 8 frequency bits
	NR14_REG = 0xC3U; // first 3 bits are the 3 highest bits of freq
	NR51_REG = 0xF7;
	return 0u;
}

UBYTE sound_fox_hit_ch1()
{
	NR10_REG = 0x34U; // 4th bit indicates if freq increases or decreases
			  // bits 5th-7th indicate sweep delay
	NR11_REG = 0x80U;
	NR12_REG = 0xF0U;
	NR13_REG = 0x0AU; //lowest 8 frequency bits
	NR14_REG = 0xC6U; // first 3 bits are the 3 highest bits of freq
	NR51_REG = 0xF7;
	return 0u;
}

UBYTE sound_swipe_no_hit_ch1()
{
	NR10_REG = 0x00U; // 4th bit indicates if freq increases or decreases
			  // bits 5th-7th indicate sweep delay
	NR11_REG = 0x80U;
	NR12_REG = 0x50U;
	NR13_REG = 0x0AU; //lowest 8 frequency bits
	NR14_REG = 0xC1U; // first 3 bits are the 3 highest bits of freq
	NR51_REG = 0xF7;
	return 0u;
}

UBYTE sound_burly_footsteps_ch2()
{
	// this happens on sound channel 2
	NR21_REG = 0x7BU;
	NR22_REG = 0x88U;
	NR23_REG = 0xAFU; // lowest 8 bits of frequency
	NR24_REG = 0xC0U; // first 3 bits are the highest 3 bits of frequency
	NR51_REG = 0xF7;
	return 0u;
}

UBYTE s()
{
	NR10_REG = 0x04U;
	NR11_REG = 0xFEU;
	NR12_REG = 0xA1U;
	NR13_REG = 0x8FU;
	NR14_REG = 0x82U;
	NR51_REG = 0xF7;
	return 0u;
}
UBYTE s2()
{
	NR10_REG = 0x04U;
	NR11_REG = 0xFEU;
	NR12_REG = 0xA1U;
	NR13_REG = 0x8FU;
	NR14_REG = 0x81U;
	NR51_REG = 0xF7;
	return 0u;
}

UBYTE sound_waiting_for_enter_ch1(UBYTE time)
{
	UBYTE i;

	s();
	for(i = 0; i < 20; i++)
	{
		wait_vbl_done();
		if((joypad() & J_START) || (joypad() & J_SELECT))return 0u;
	}
	s();
	for(i = 0; i < 20; i++)
	{
		wait_vbl_done();
		if((joypad() & J_START) || (joypad() & J_SELECT))return 0u;
	}

	for(i = 0; i < 40; i++)
	{
		wait_vbl_done();
		if((joypad() & J_START) || (joypad() & J_SELECT))return 0u;
	}

	s2();
	for(i = 0; i < 20; i++)
	{
		wait_vbl_done();
		if((joypad() & J_START) || (joypad() & J_SELECT))return 0u;
	}
	s2();

	return 0u;
}

UBYTE medley()
{
	UBYTE i;

	while(1)
	{
		sound_swipe_no_hit_ch1();
		for(i = 0; i < 100; i++)  wait_vbl_done();
	}
	
	return 0u;
}
